﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private cmbCountries As String
	Private DBdata As String
	Public Height As String
	Public Width As String
	Public Filtering As Boolean
	Public Inserting As Boolean
	Public Editing As Boolean
	Public Sorting As Boolean
	Public Paging As Boolean
	Public AutoLoad As Boolean
	Public PageSize As Int
	Public PageButtonCount As Int
	Public DeleteConfirm As String
	Public Selecting As Boolean
	Public Heading As Boolean
	Public PageLoading As Boolean
	Public ConfirmDeleting As Boolean
	Public UpdateOnResize As Boolean
	Private loadIndication As Boolean
	Private loadIndicationDelay As Int
	Private loadMessage As String
	Private loadShading As Boolean
	Private FieldNames As List
	Private Labels As List
	Private Types As List
	Private UseInUpdates As List
	Private OverviewVisibles As List
	Private OverviewSorts As List
	Private OverviewWidths As List
	Private Columns As Map
	Type GridFieldTypesEnum(field_text As String, field_number As String, field_checkbox As String, field_select As String, field_textarea As String, field_control As String)
	Public EnumFieldTypes As GridFieldTypesEnum
	Type GridFieldAlignEnum(align_left As String, align_center As String, align_right As String)
	Public EnumFieldAlign As GridFieldAlignEnum
	Private pg As ABMPage
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, Countries As String, data As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID, "")	
	cmbCountries = Countries
	DBdata = data
End Sub

Public Sub InitializeMash(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID, "")	
	pg = InternalPage
	MashPrepare(InternalPage)
End Sub

'prepare the grid
private Sub MashPrepare(InternalPage As ABMPage)
	pg = InternalPage
	Height = "100%"
	Width = "100%"
	Filtering = True
	Inserting = True
	Editing = True
	Sorting = True
	Paging = True
	AutoLoad = True
	PageSize = 10
	PageButtonCount = 5
	Selecting = True
	Heading = True
	PageLoading = False
	ConfirmDeleting = False 'IMPORTANT - internet explorer alert wont show if false
	UpdateOnResize = True
	DeleteConfirm = "Do you really want to delete this record?"
	loadIndication = True
	loadIndicationDelay = 500
	loadMessage = "Please, wait..."
	loadShading = True
	FieldNames.initialize
	Labels.initialize
	Types.initialize
	UseInUpdates.initialize
	OverviewVisibles.initialize
	OverviewSorts.initialize
	OverviewWidths.initialize
	Columns.initialize
	'initialize the fields
	EnumFieldTypes.initialize
	EnumFieldTypes.field_text = "text"
	EnumFieldTypes.field_number = "number"
	EnumFieldTypes.field_select = "select"
	EnumFieldTypes.field_textarea = "textarea"
	EnumFieldTypes.field_control = "control"
	EnumFieldTypes.field_checkbox = "checkbox"
	EnumFieldAlign.Initialize
	EnumFieldAlign.align_left = "left"
	EnumFieldAlign.align_center = "center"
	EnumFieldAlign.align_right = "right"
End Sub

Sub ABMComp_Build(InternalPage As ABMPage, internalID As String) As String
	pg = InternalPage
  Return $"<div id="${internalID}"></div><script>var _${internalID};</script>"$
End Sub

'set loading properties
Sub MashSetLoading(bloadIndication As Boolean,iloadIndicationDelay As Int, sloadMessage As String, bloadShading As Boolean)
	loadIndication = bloadIndication
	loadIndicationDelay = iloadIndicationDelay
	loadMessage = sloadMessage
	loadShading = bloadShading
End Sub

'add a column to the table
Sub MashAddColumn(sTypeOf As String,sFldName As String,sTitle As String,sAlign As String, sWidth As String)
	Dim nField As Map
	If sWidth = "" Then sWidth = "50"
	'items for the combo box, create a blank list
	Dim lItems As List
	lItems.Initialize 
	nField = CreateMap("type":sTypeOf, _
	"name": sFldName, _
	"title": sTitle, _
	"align": sAlign, _
	"width": sWidth, _
	"visible": True, _
	"filtering": True, _
	"inserting": True, _
	"editing": True, _
	"sorting": True, _
	"readonly": False, _
	"autosearch": False, _
	"valuefield": "", _
	"textfield": "", _
	"items":lItems)
	Columns.put(sFldName.tolowercase,nField)
End Sub

'return a string inside quotes
private Sub MashInQuotes(sValue As String) As String
	Return (QUOTE & sValue & QUOTE)
End Sub

'build the columns to appear in the table
public Sub MashBuildColumns() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each fldKey As String In Columns.Keys
		'get the field definition
		Dim fldMap As Map = Columns.Get(fldKey)
		'define the column builder
		Dim scolumn As StringBuilder
		scolumn.Initialize
		scolumn.Append("{ ")
		'get the type and name
		Dim fType As String = fldMap.Get("type")
		Dim fName As String = fldMap.Get("name")
		Select Case fType
		Case EnumFieldTypes.field_control
			'if its a control, do nothing much on definition
			scolumn.Append("type: ").Append(MashInQuotes(fType))
		Case Else
			'explode the column definition
			scolumn.Append("name:").Append(MashInQuotes(fName)).Append(", ")
			scolumn.Append("type: ").Append(MashInQuotes(fType)).Append(", ")
			scolumn.Append("title:").Append(MashInQuotes(fldMap.Get("title"))).Append(", ")
			scolumn.Append("width:").Append(fldMap.Get("width")).Append(", ")
			scolumn.Append("align:").Append(MashInQuotes(fldMap.Get("align"))).Append(", ")
			scolumn.Append("visible:").Append(fldMap.Get("visible")).Append(", ")
			scolumn.Append("filtering:").Append(fldMap.Get("filtering")).Append(", ")
			scolumn.Append("inserting:").Append(fldMap.Get("inserting")).Append(", ")
			scolumn.Append("editing:").Append(fldMap.Get("editing")).Append(", ")
			scolumn.Append("sorting:").Append(fldMap.Get("sorting")).Append(", ")
			scolumn.Append("readonly:").Append(fldMap.Get("readonly")).Append(", ")
			scolumn.Append("autosearch:").Append(fldMap.Get("autosearch"))
			Select Case fType
			Case EnumFieldTypes.field_select
				'we have a combo, it has extra properties
				scolumn.Append(",")
				'get the list to select from
				Dim selList As List = fldMap.Get("items")
				Dim selItems As String = "[" & MashJoin(selList,",") & "]"
				scolumn.Append("items: ").Append(selItems).Append(",")
				scolumn.Append("valuefield:").Append(MashInQuotes(fldMap.Get("valuefield"))).Append(",")
				scolumn.Append("textfield:").Append(MashInQuotes(fldMap.Get("textfield")))
			End Select
		End Select
		scolumn.Append("}")
		'add each column definition	
		sb.Append(scolumn.ToString).Append(",")
	Next
	'remove trailing comma
	If sb.ToString.EndsWith(",") Then
		sb.Remove(sb.Length-1,sb.Length)
	End If
	Return sb.tostring
End Sub

'join a list and make it a string
private Sub MashJoin(lst As List, Delim As String) As String
	Dim lStr As StringBuilder
	lStr.Initialize
	For Each strValue As String In lst
		lStr.Append(strValue).Append(Delim)
	Next
	If lStr.ToString.EndsWith(Delim) Then
		lStr.Remove(lStr.Length-Delim.length,lStr.Length)
	End If
	Return lStr.tostring
End Sub

'add a text column
Sub MashAddText(sFldName As String,sTitle As String, sWidth As String)
	MashAddColumn(EnumFieldTypes.field_text,sFldName,sTitle, EnumFieldAlign.align_left,sWidth)	
End Sub

'add a number column
Sub MashAddNumber(sFldName As String,sTitle As String, sWidth As String)
	MashAddColumn(EnumFieldTypes.field_number,sFldName,sTitle,EnumFieldAlign.align_right,sWidth)	
End Sub

'add a checkbox column
Sub MashAddCheckBox(sFldName As String,sTitle As String, sWidth As String)
	MashAddColumn(EnumFieldTypes.field_checkbox,sFldName,sTitle,EnumFieldAlign.align_center,sWidth)	
End Sub

'add a combo column
Sub MashAddSelect(sFldName As String,sTitle As String, sWidth As String)
	MashAddColumn(EnumFieldTypes.field_select,sFldName,sTitle,EnumFieldAlign.align_left,sWidth)	
End Sub

'add a text area column
Sub MashAddTextArea(sFldName As String,sTitle As String, sWidth As String)
	MashAddColumn(EnumFieldTypes.field_textarea,sFldName,sTitle,EnumFieldAlign.align_left,sWidth)	
End Sub

'add commands
Sub MashAddControl()
	MashAddColumn(EnumFieldTypes.field_control,"control","Commands",EnumFieldAlign.align_right,"auto")	
End Sub


'set a select column details i.e. value field and textfield and contents
Sub MashSetSelect(sFieldName As String, sValueField As String, sTextField As String, values As Map)
	sFieldName = sFieldName.tolowercase
	If Columns.ContainsKey(sFieldName) Then 
		'get the column definition
		Dim oField As Map = Columns.Get(sFieldName)
		Dim oList As List = oField.Get("items")
		'indicate the value and textfield for the column
		oField.Put("valuefield", sValueField)
		oField.Put("textfield", sTextField)
		'add to the select list all items provided
		For Each strKey As String In values.Keys
			Dim strValue As String = values.Get(strKey)
			'define the column combo properties
			Dim item As String = $"{${sTextField}: "${strValue}", ${sValueField}: ${strKey}}"$
			'update the list with the new item
			If oList.IndexOf(item) = -1 Then oList.Add(item)
		Next	
		'update the items property of the column definition
		oField.Put("items", oList)
		'update the master column definitions
		Columns.Put(sFieldName,oField)
	Else
		Log("MashSetSelect: " & sFieldName & " not found!")
	End If
End Sub

'set the field names
Public Sub Set01FieldNames(Values As List)
	For Each strField As String In Values
		FieldNames.Add(strField)
	Next
End Sub

'set the headings
Public Sub Set03LabelTexts(Values As List)
	For Each strLabel As String In Values
		Labels.Add(strLabel)
	Next
End Sub

'set the component types
Public Sub Set04ComponentTypes(Values As List)
	For Each strComponent As String In Values
		Types.Add(strComponent)
	Next
End Sub

'set the updatability
Public Sub Set10UseInUpdates(Values As List)
	For Each strBoolean As String In Values
		If strBoolean = "1" Then strBoolean = True
		If strBoolean = "0" Then strBoolean = False
		UseInUpdates.Add(strBoolean)
	Next
End Sub

'set sortability
Public Sub Set15OverviewSortable(Values As List)
	For Each strBoolean As String In Values
		If strBoolean = "1" Then strBoolean = True
		If strBoolean = "0" Then strBoolean = False
		OverviewSorts.Add(strBoolean)
	Next
End Sub

'set widths
Public Sub Set17OverviewColumnWidths(Values As List)
	For Each strWidth As String In Values
		OverviewWidths.Add(strWidth)
	Next
End Sub

'set visibility
Public Sub Set11OverviewVisible(Values As List)
	For Each strBoolean As String In Values
		If strBoolean = "1" Then strBoolean = True
		If strBoolean = "0" Then strBoolean = False
		OverviewVisibles.Add(strBoolean)
	Next
End Sub


Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	pg = InternalPage
  Dim script As String = $"_${internalID} = $("#${internalID}").jsGrid({
        height: "${Height}", 
        width: "${Width}",
        filtering: ${Filtering},
		inserting: ${Inserting},
        editing: ${Editing},
        sorting: ${Sorting},
        paging: ${Paging},
		heading: ${Heading},
		selecting: ${Selecting},
        autoload: ${AutoLoad},
		pageloading: ${PageLoading},
        pagesize: ${PageSize},
		loadindication: ${loadIndication},
		loadindicationDelay: ${loadIndicationDelay},
		loadmessage: "${loadMessage}",
		loadshading: ${loadShading},
		confirmdeleting: ${ConfirmDeleting},
        pagebuttoncount: ${PageButtonCount},
		updateonresize: ${UpdateOnResize},
        deleteconfirm: "${DeleteConfirm}",
        controller: {
			loadData: function(filter) {
				return $.grep(${DBdata}, function(client) {
				    var fName = filter.Name.toUpperCase();
					var fAddress = filter.Address.toUpperCase();
					return (!filter.Name || client.Name.toUpperCase().indexOf(fName) > -1)
                    	&& (!filter.Age || client.Age === filter.Age)
                    	&& (!filter.Address || client.Address.toUpperCase().indexOf(fAddress) > -1)
                    	&& (!filter.Country || client.Country === filter.Country)
                    	&& (filter.Married === undefined || client.Married === filter.Married);
            		});							
			},
			insertItem: function(insertingClient) {
			    var json = JSON.stringify(insertingClient);
         	    b4j_raiseEvent('${ABMComp.ID}_inserted', {'value':json});
        	},
        	updateItem: function(updatingClient) { 
				var json = JSON.stringify(updatingClient);
				b4j_raiseEvent('${ABMComp.ID}_updated', {'value':json});
			},
        	deleteItem: function(deletingClient) {
				var json = JSON.stringify(deletingClient);
            	b4j_raiseEvent('${ABMComp.ID}_deleted', {'value':json});
        	}	
		},
        fields: [ ${MashBuildColumns}
        ]
    });"$

  InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
  ' flush not needed, it's done in the refresh method in the lib
End Sub

public Sub SetDBData(data As String) 
	DBdata = data
End Sub

Sub MashReset
	Dim script As String = $"$("#${ABMComp.id}").jsGrid("reset");"$
	pg.ws.Eval(script, Null)
End Sub

Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	pg = InternalPage
  Dim script As String = $"$("#${internalID}").jsGrid("refresh");"$
  InternalPage.ws.Eval(script, Null)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)

End Sub

